/*
     hostOS-    file_control
     
*/


#include <sys/param.h>
#include <sys/mount.h>
#include <ncurses.h>

//          ( 256- )
// mountp      ASCIZ, free      int
void get_statfs_info(char *fn, char **mountp, unsigned int *free) {
  static struct statfs buf;
  char empty_str[1] = {0};
  unsigned long long t, d;

  if (statfs(fn, &buf)) {
    *mountp = empty_str;
    *free = 0;
  } else {
//    mountp = buf.f_fstypename;	//   
//    mountp = buf.f_mntfromname;	// ,  
    *mountp = buf.f_mntonname;		//  
    t = (unsigned long long)buf.f_bsize * (unsigned long long)buf.f_bavail;
    d = t >> 8;
    if (d > 0xFFFFFFF) { *free = 0xFFFFFFF; } else { *free = d; };
  }
}


//    curses-   
void winborder(int x1, int y1, int x2, int y2) {
  int x, y;

  mvaddch(y1, x1, ACS_ULCORNER); for (x = x1 + 1; x < x2; x++) addch(ACS_HLINE); addch(ACS_URCORNER);
  for (y = y1 + 1; y < y2; y++) {
    mvaddch(y, x1, ACS_VLINE);
    for (x = x1 + 1; x < x2; x++) addch(' ');
    addch(ACS_VLINE);
  };
  mvaddch(y2, x1, ACS_LLCORNER); for (x = x1 + 1; x < x2; x++) addch(ACS_HLINE); addch(ACS_LRCORNER);
}
