/*
  C-  mcrt.pp
        
*/

#include <curses.h>
#include <stdio.h>
#include <stdlib.h>

static int col[8][8];


void m_init_pair() {
  int i, j, c = 1,
    c_ind[8]={COLOR_BLACK, COLOR_BLUE, COLOR_GREEN, COLOR_CYAN, 
	      COLOR_RED, COLOR_MAGENTA, COLOR_YELLOW, COLOR_WHITE};

  for (i = 0; i <= 7; i++) for (j = 0; j <= 7; j++) if (i == j) {
    col[i][j] = 0;
  } else {
    if (c > COLOR_PAIRS-1) { printf("mcrt: COLOR_PAIRS fault (max = %d)\n", COLOR_PAIRS); exit(12); }
    init_pair(c, c_ind[j], c_ind[i]);
    col[i][j] = c;
    c++;
  }
}

void m_setattr(char c) {
  if (c & 0x08) { attron(A_BOLD); } else { attroff(A_BOLD); };
  attron(  COLOR_PAIR( col[ (c >> 4) & 0x07 ] [ (c     ) & 0x07 ] ) );
}

void m_setbg(char c) {
  bkgdset( COLOR_PAIR( col[ (c >> 4) & 0x07 ] [ (c     ) & 0x07 ] ) );
}

void m_getyx(WINDOW *win, int *y, int *x) {
  getyx(win, *y, *x);
}

void m_getparyx(WINDOW *win, int *y, int *x) {
  getparyx(win, *y, *x);
}

void m_getbegyx(WINDOW *win, int *y, int *x) {
  getbegyx(win, *y, *x);
}

void m_getmaxyx(WINDOW *win, int *y, int *x) {
  getmaxyx(win, *y, *x);
}
		      