uses dos;

const
  tKOI2Host	: Array[#128..#255] of Char = (
{$ifdef GO32V2}
    #$C4, #$B3, #$DA, #$BF,  #$C0, #$D9, #$C3, #$B4,  #$C2, #$C1, #$C5, #$DF,  #$DC, #$DB, #$DD, #$DE,
    #$B0, #$B1, #$B2, #$F4,  #$FE, #$F9, #$FB, #$F7,  #$F3, #$F2, #$FF, #$F5,  #$F8, #$FD, #$FA, #$F6,
    #$CD, #$BA, #$D5, #$F1,  #$D6, #$C9, #$B8, #$B7,  #$BB, #$D4, #$D3, #$C8,  #$BE, #$BD, #$BC, #$C6,
    #$C7, #$CC, #$B5, #$F0,  #$B6, #$B9, #$D1, #$D2,  #$CB, #$CF, #$D0, #$CA,  #$D8, #$D7, #$CE, #$FC,
    #$EE, #$A0, #$A1, #$E6,  #$A4, #$A5, #$E4, #$A3,  #$E5, #$A8, #$A9, #$AA,  #$AB, #$AC, #$AD, #$AE,
    #$AF, #$EF, #$E0, #$E1,  #$E2, #$E3, #$A6, #$A2,  #$EC, #$EB, #$A7, #$E8,  #$ED, #$E9, #$E7, #$EA,
    #$9E, #$80, #$81, #$96,  #$84, #$85, #$94, #$83,  #$95, #$88, #$89, #$8A,  #$8B, #$8C, #$8D, #$8E,
    #$8F, #$9F, #$90, #$91,  #$92, #$93, #$86, #$82,  #$9C, #$9B, #$87, #$98,  #$9D, #$99, #$97, #$9A
{$endif}
{$ifdef WINDOWS}
    #$2D, #$A6, #$2D, #$AC,  #$4C, #$2D, #$2B, #$2B,  #$54, #$2B, #$2B, #$2D,  #$2D, #$2D, #$A6, #$A6,
    #$2D, #$2D, #$2D, #$AF,  #$A6, #$95, #$76, #$A2,  #$BA, #$AA, #$20, #$BF,  #$B0, #$A4, #$B7, #$A1,
    #$3D, #$A6, #$2D, #$B8,  #$E3, #$E3, #$AC, #$AC,  #$AC, #$4C, #$4C, #$4C,  #$2D, #$2D, #$2D, #$A6,
    #$A6, #$A6, #$A6, #$A8,  #$A6, #$A6, #$54, #$54,  #$54, #$A6, #$A6, #$A6,  #$2B, #$2B, #$2B, #$B9,
    #$FE, #$E0, #$E1, #$F6,  #$E4, #$E5, #$F4, #$E3,  #$F5, #$E8, #$E9, #$EA,  #$EB, #$EC, #$ED, #$EE,
    #$EF, #$FF, #$F0, #$F1,  #$F2, #$F3, #$E6, #$E2,  #$FC, #$FB, #$E7, #$F8,  #$FD, #$F9, #$F7, #$FA,
    #$DE, #$C0, #$C1, #$D6,  #$C4, #$C5, #$D4, #$C3,  #$D5, #$C8, #$C9, #$CA,  #$CB, #$CC, #$CD, #$CE,
    #$CF, #$DF, #$D0, #$D1,  #$D2, #$D3, #$C6, #$C2,  #$DC, #$DB, #$C7, #$D8,  #$DD, #$D9, #$D7, #$DA
{$endif}
  );

var
  SR	: SearchRec;
  buf	: Array[1..1024*1024] of Char;
  size	: Cardinal;
  n	: Cardinal;
  f	: File;
  nname	: String;

begin
  if not LFNSupport then runerror(11);

  FindFirst('*.KOI', 0, SR);
  While DosError = 0 do begin

    FileMode := 0;
    assign(f, SR.name); reset(f, 1); blockread(f, buf, sizeof(buf), size); close(f);

    for n := 1 to size do if buf[n] >= #128 then buf[n] := tKOI2Host[ buf[n] ];

    nname := SR.name;
    if UpCase( copy(nname, length(nname) - 3, 4) ) <> '.KOI' then runerror(10);
    delete(nname, length(nname) - 3, 4);

    writeln(SR.name, ' -> ', nname);

    FileMode := 1;
    assign(f, nname); rewrite(f, 1); blockwrite(f, buf, size); close(f);

    FindNext(SR);

  end;
  FindClose(SR);
end.
