#!/bin/sh


n=dsk_to_fil_test.pp
n=view_dir_test.pp
n=graph_proc.pp
n=format_control.pp
n=immap.pp
n=dos33c2
#n=menu

clear

gcc -c -ggdb host_os_specific_c.c || { sleep 4; exit; }
gcc -c -ggdb msubcrt.c || { sleep 4; exit; }
gcc -c -ggdb `imlib2-config --cflags`  x11_graph_viewer.c || { sleep 4; exit; }

# `imlib2-config --libs`


for d in ../_HumanInterface ../_Core2
do
  for f in $d/*.KOI
  do
    ln $f ${f%.KOI}
  done
done


if /usr/home/deka/FPC2/bin/ppc386 -Cs10240000 -gl \
   -Fu../_Core2 -Fi../_Core2 \
   -Fu../_HumanInterface -Fi../_HumanInterface \
   ../_HumanInterface/$n
then
  sleep 2
  rm *.o *.ppu
  cd ..
  _HumanInterface/dos33c2
else
  sleep 4
  cd ..
fi


for d in _HumanInterface _Core2
do
  rm -f $d/*.pp $d/*.inc
done
